;***********************
; Si programa atlieka XOR operacija tarp 2 dvejetainiu skaiciu esanciu failuose
; ir atspausdina rezultata i trecia parametra 
; Autorius: xxxxx, PS xgr
;***********************

.model small

;.386    ;reik tasmui          

rBuferioDydis   EQU 40          ; konstantos
sBuferioDydis   EQU 40
.stack 100h                 

.data                                                                                                         

    pagalbosPranesimas 			db "Programos autorius: Audrius Kumpis, PS 2 gr", 0Ah, 0Dh, "Programa atlieka XOR logine operacija tarp 2 failu", 0Ah, 0Dh, "Rezultata iraso i trecia parametra", 0Ah, 0Dh, "pvz, antra.exe duomenuFailas1.txt duomenuFailas2.txt rezultatuFailas.txt$"
    nepavyko    				db "Nepavyko sukurti failo$" 
    dFailoAtidarymoKlaida 		db "Nepavyko atidaryti duomenu failo. Patikrink pavadinima$"
    mazaiParametru   			db "Ivesta mazai parametru, reikia 3$"
    perDaug    					db "Per daug parametru$" 
    klaidaIrasantPranesimas    	db "Klaida irasant i faila$"
    nepavykoSkaitytiKlaida     	db "Klaida skaitant faia$"                                         
    dalinis                     db "Dalinis irasymas$"
    netinkamasParametras       	db "Netinkamas trecias parametras. Turi baigtis .txt",0Ah, 0Dh, 24h 
    nevienodi                   db "Nevienodi parametru ilgiai, negalima atlikti operacijos$"
    blogiDuomenys               db "Blogi duomenys. Faile(-uose) turi but tik dvejetainiai skaiciai$"   
    klaidaUzdarantS             db "Klaida uzdarant duomenu faila$"
    klaidaUzdarantR             db "Klaida uzdarant rezultatu faila$"  
    sekminga                    db "Programa baige darba sekmingai$"
    duomenuPirmasFailas		   	db 15 dup (0)
	duomenuAntrasFailas 	   	db 15 dup (0)  
    rezultatuFailas 		   	db 15 dup (0) 
    null 						db 0 
    skaitymoPirmasBuferis   	db sBuferioDydis dup (0)  
    skaitymoAntrasBuferis   	db sBuferioDydis dup (0)  
    rasymoBuferis 				db rBuferioDydis dup (0)
    rezultatuParametroIlgis		db 0  
    fragmentas 					db ".txt"
    flag 						db 0
    rFailoKodas 				dw ? 
    d1FailoKodas			    dw ?
    d2FailoKodas			    dw ?
    pirmoDuomBufIlgis           dw 0
    antroDuomBufIlgis           dw 0    
    liko                        dw 0  
    rezFailoIlgis               dw 0     

.code
    start:
        mov ax, @data
        mov ds, ax
    
        xor cx, cx
        mov cl, es:80h  ; i cl keliam kiek simboliu ivesta i komandine eilute
        dec cl          
        cmp cl, 0       ; jei nulis, spausdinam pagalba
        je pagalba  
        dec cl          ; sumazinam cl, kad neskaitytu tarpo
        
        mov bx, 82h     ; 81h-bus tarpas, tai ivesti simboliai prasideda nuo 82h
    
    ieskokPagalbos:
        ;cmp word ptr [es:bx], '?/' ;*tokio reik tasmui*
        cmp es:bx, '?/' ; nusiskaito atvirkscia tvarka
        je pagalba
        inc bx          ; einam i kita baita
        loop ieskokPagalbos             ; pereinam visus simbolius. Jei nebuvo /?, tesiam darba
        
        xor cx, cx                
        mov cl, es:80h  ; atnaujiam cl 
        cmp cl, 0
        je pagalba  
        dec cl          ; del tarpo susimazinam
         
        mov bx, 82h 
        mov bp, offset duomenuPirmasFailas    ; bp laikysim temp duom failo pavadinimo adresa
        
    ieskokPirmoParametro:               
        mov ax, es:bx                   ; i ax keliam pirma (nu antra) eilutes simboli 
        mov ds:[bp+si], al              ; i duomenu segmente esanti d. failo pavadinimo adresa keliam po 1 simboli
        inc si                          ; rasysim i kita baita
        inc bx                          ; zurim kita baita         
             
        cmp al, 20h                     ; jei radom tarpa
        je pirmoParametroPabaiga        ; baigiam skaityt pirma parametra
        loop ieskokPirmoParametro       ; jei ne, perskaitom viska iki tarpo
               
     pirmoParametroPabaiga:
        dec si                          ; mazinam si, kad ziuretu i baito po paskutinio simbolio
        mov byte ptr ds:[bp+si], 0      ; irasom 0, ne failas skaito iki 0 zenklo. Realiai nereikia nes masyva uzpildem nuliais
        mov bp, offset duomenuAntrasFailas  ; kartojam su antro failo pavadinimu
        
        xor si, si                      ; nusivalom si
        cmp cl, 0                       ; jei baigesi ivesti simboliai
        je vienas                       ; buvo ivestas tik 1 zodis
                                                              
    ieskokAntroParametro:   
        mov ax, es:bx                   ; nusiskaitom rez faila
        mov ds:[bp+si], al
        inc si
        inc bx
        
        cmp al, 20h
        je antroParametroPabaiga  
        loop ieskokAntroParametro
    antroParametroPabaiga:
        dec si
        mov byte ptr ds:[bp+si], 0 
                                        
        cmp cl, 0                       ; jei dar yra simboliu
        je vienas             ; buvo per mazai parametru. mums reik 3
		
; ****** trecias parametras************   

        mov bp, offset rezultatuFailas  ; kartojam su rez failo pavadinimu
        
        xor si, si                      ; nusivalom si
        cmp cl, 0                       ; jei baigesi ivesti simboliai
        je vienas                       ; buvo ivestas tik 2 zodziai
                                                              
    ieskokTrecioParametro:   
        mov ax, es:bx                   ; nusiskaitom rez faila
        mov ds:[bp+si], al
        inc si
        inc bx
		inc rezultatuParametroIlgis
        
        cmp al, 20h
        je trecioParametroPabaiga 
		
        loop ieskokTrecioParametro 
        dec rezultatuParametroIlgis 
        dec rezultatuParametroIlgis
		
    trecioParametroPabaiga:
        dec si
        dec si
        mov byte ptr ds:[bp+si], 0 
                                        
        cmp cl, 0                       ; jei dar yra simboliu
        jg perDaugParametru             ; buvo per daug parametru. mums reik tik 2

; ********************* trecio param pabaiga *********************       

        call patikrinkTreciaParametra

    atidarykPirmaFaila: 
        call OpenFirstFile
        
    atidarykAntraFaila:
        call OpenSecondFile
        
    ; *****************************
    ; nuskaitys is duom failo ir ikels i skaitymobuf, cia turi but PROC
    ; *****************************       
    
    skaityk:   
; ******* pirmo failo skaitymas ************************                          
        mov ah, 3Fh                      ; failo skaitymo kodas
        mov bx, d1FailoKodas             ; paduodam duom failo deskriptoriaus koda
        mov cx, sBuferioDydis            ; <-- KIEK SKAITYT BAITU IS FAILO
        mov dx, offset skaitymoPirmasBuferis   ; paduodam kur ikels tai ka nuskaite
        int 21h
        jc nepavykoSkaityti              ; jei nepavyko, pabaiga 
        call gautiPirmoBufIlgi
        
; ******* antro failo skaitymas ************************                          
        mov ah, 3Fh                      ; failo skaitymo kodas
        mov bx, d2FailoKodas             ; paduodam duom failo deskriptoriaus koda
        mov cx, sBuferioDydis            ; <-- KIEK SKAITYT BAITU IS FAILO
        mov dx, offset skaitymoAntrasBuferis   ; paduodam kur ikels tai ka nuskaite
        int 21h
        jc nepavykoSkaityti              ; jei nepavyko, pabaiga 
        call gautiAntroBufIlgi     
        
;*********************** cia gali but klaida reik paduot buferiu adresus          
                     
    failoSukurimas:
        mov ah, 3Ch                      ; sukuriam faila
        mov cx, 0                        ; normalus-be atribiutu failas(zr emu help) 
        mov dx, offset rezultatuFailas   ; paduodam rezfailo pavadinima
        int 21h
        jc nepavykoSukurti               ; jei nepavyko sukurt
        mov rFailoKodas, ax              ; jei pavyko, paduodam rez failo deskriptoriaus koda
		
;==================================
; Cia bus pagrindinis programos algoritmas
;================================== 

; Tikrinam ar vienodas duomenu ilgis
  
      ;  mov ax, pirmoDuomBufIlgis
      ;  mov bx, antroDuomBufIlgis
      ;  cmp ax, bx
      ;  jne nevienodiIlgiai 
        
; Sukuriame rezultatu buferi              ******************************************
        call SukurkRezultata
        
    irasymas:   
        
    
        mov cx, rezFailoIlgis        ; <-- KIEK IRASYT BAITU IS FAILO
        mov bx, rFailoKodas              ; paduodam failo, i kuri rasysim, koda (rez)
        mov dx, offset rasymoBuferis     ; paduodam ka reikia irasyt
        call WriteToFile                 ; funkcija
        jc klaida                        ; jei nepaejo, klaida
        
    uzdarytiDuom1:
        mov ah, 3Eh
        mov bx, d1FailoKodas
        int 21h
        jc klaidaUzdarantSkaitymui 
        
    uzdarytiDuom2:
        mov ah, 3Eh
        mov bx, d2FailoKodas
        int 21h
        jc klaidaUzdarantSkaitymui
    
    uzdarytiRez:
        mov ah, 3Eh
        mov bx, rFailoKodas
        int 21h
        jc klaidaUzdarantRasymui    
        
        mov dx, offset sekminga
        call PrintSTDOUT
        jmp pabaiga                      ; CIA BAIGIASI KOLKAS PROGRAMA **************************************************************

;******************************
; KLAIDOS IR INFORMACIJA
;******************************    
    pagalba:
        mov dx, offset pagalbosPranesimas ; pagalbos pranesimas
        call PrintSTDOUT                  
        jmp pabaiga 
        
    klaidaUzdarantSkaitymui:
        mov dx, offset klaidaUzdarantS
        call PrintSTDOUT
        jmp pabaiga 
        
    klaidaUzdarantRasymui:
        mov dx, offset klaidaUzdarantR
        call PrintSTDOUT
        jmp pabaiga
        
    nevienodiIlgiai:
        mov dx, offset nevienodi
        call PrintSTDOUT
        jmp pabaiga
        
    nepavykoSkaityti:
        mov dx, offset nepavykoSkaitytiKlaida
        call PrintSTDOUT
        jmp pabaiga
        
    perDaugParametru:
        mov dx, offset perDaug            ; per daug parametru
        call PrintSTDOUT
        jmp pabaiga 
        
    nepavykoSukurti:                      ; nepavyko sukurti
        mov dx, offset nepavyko           
        call PrintSTDOUT
        jmp pabaiga 
        
    nepavykoAtidarytiDuomenuFailo:            ; jei nepavyko atidaryt duomenu failo
        mov dx, offset dFailoAtidarymoKlaida ; REIKES ATSPAUSDINT PAGALBA
        call PrintSTDOUT
        jmp pabaiga
                                          ; jei tik vienas parametras
    vienas:
        mov dx, offset mazaiParametru
        call PrintSTDOUT
        jmp pabaiga
;****************************        
; pabaiga
    pabaiga:
        mov ah, 4Ch
        int 21h  
;****************************   

;*************************
; PROCEDUROS
;*************************   

; SKAICIUOJA REZULTATA. 2 FAILAMS ATLIEKA 'XOR' OPERACIJA

    PROC SukurkRezultata
        
        push ax
        push bx
        push cx
        push dx 
        push bp
        push di
        
        mov bx, offset skaitymoPirmasBuferis ; pirmo failo duomenys
        mov bp, offset skaitymoAntrasBuferis ; antro failo duomenys      
        mov di, offset rasymoBuferis         ; rezultatu buferis
        
        xor si, si                                              
        xor cx, cx
        xor ax, ax    
        
        mov ax, pirmoDuomBufIlgis 
        mov dx, antroDuomBufIlgis
        cmp ax, dx
        jg pirmasDidesnis
        mov cx, pirmoDuomBufIlgis  
        sub dx, ax
        mov liko, dx
        
        xor ax, ax
        
       ; mov cx, pirmoDuomBufIlgis            ; kiek yra elementu
        
      rezCiklas:
        mov al, byte ptr [bx]
        mov ah, byte ptr ds:[bp+si]
        
        cmp al, 30h
        jb blogasSk
        cmp al, 31h
        ja blogasSk
        
        cmp ah, 30h
        jb blogasSk
        cmp ah, 31h
        ja blogasSk
        
        cmp al, ah
        je rasyk0
        cmp al, ah
        jne rasyk1
        
      rasyk1:
        cmp cl, 0
        je dedamNulius  
         
        inc rezFailoIlgis
         
        mov byte ptr [di], '1'
        inc bx
        inc si
        inc di     
               
        loop rezCiklas 
      rasyk0: 
        cmp cl, 0
        je dedamNulius 
        
        inc rezFailoIlgis
        
        mov byte ptr [di], '0'
        inc bx
        inc si
        inc di     
               
        loop rezCiklas
        jmp dedamNulius
        
      blogasSk:
        mov dx, offset blogiDuomenys
        call PrintSTDOUT
        jmp pabaiga  
       
      pirmasDidesnis:
        mov cx, antroDuomBufIlgis 
        mov dx, pirmoDuomBufIlgis
        sub dx, cx
        mov liko, dx
        jmp rezCiklas 
        
      dedamNulius:        
        mov cx, liko
      dedam:       
        mov byte ptr [di], '0'
        inc di     
        inc rezFailoIlgis
        loop dedam
        jmp rezProcPabaiga            
        
          
      rezProcPabaiga:
        
        pop di
        pop bp
        pop dx
        pop cx
        pop bx
        pop ax
        
        ret        
        
    SukurkRezultata ENDP

; GAUTI BUFERIU ILGIUS
    PROC gautiPirmoBufIlgi
        
        push ax
        push bx
        
        xor ax, ax    
        mov bx, offset skaitymoPirmasBuferis
        
      raskIlgi:
        mov al, byte ptr [bx]
        cmp al, 0
        je stop
        inc pirmoDuomBufIlgis 
        inc bx
        jmp raskIlgi 
      stop:
        
        pop bx
        pop ax
        
        ret        
        
    gautiPirmoBufIlgi ENDP                    
    
; ***************************************    

    PROC gautiAntroBufIlgi
        
        push ax
        push bx
        
        xor ax, ax    
        mov bx, offset skaitymoAntrasBuferis
        
      raskIlgi2:
        mov al, byte ptr [bx]
        cmp al, 0
        je stop2
        inc antroDuomBufIlgis 
        inc bx
        jmp raskIlgi2 
      stop2:
        
        pop bx
        pop ax
        
        ret        
        
    gautiAntroBufIlgi ENDP

; ATIDARYK PIRMA FAILA    

    PROC OpenFirstFile 
        push ax
        push dx
        
        mov dx, offset duomenuPirmasFailas     ; paduodam duom failo pavadinima 
        mov al, 0h                       ;al=0 -> read 
        mov ah, 3Dh                      ; atidaryt faila  
        int 21h                          ; atidaro faila
        jc nepavykoAtidarytiDuomenuFailo ; jei klaida, spausdinam pranesima   
        mov d1FailoKodas, ax             ; jei viskas ok, paduodam duom failo deskribtoriu
        
        pop dx
        pop ax
        ret
        
    OpenFirstFile ENDP 
    
; ATIDARYK ANTRA FAILA

    PROC OpenSecondFile      
        
        push ax
        push dx
        
        mov dx, offset duomenuAntrasFailas     ; paduodam duom failo pavadinima 
        mov al, 0h                       ;al=0 -> read 
        mov ah, 3Dh                      ; atidaryt faila  
        int 21h                          ; atidaro faila
        jc nepavykoAtidarytiDuomenuFailo ; jei klaida, spausdinam pranesima   
        mov d2FailoKodas, ax             ; jei viskas ok, paduodam duom failo deskribtoriu
        
        pop dx
        pop ax
        ret
        
    OpenSecondFile ENDP    

; SPAUSDINK SU AH-09h
        
    PROC PrintSTDOUT
        push ax
        
        mov ah, 09h
        int 21h
        
        pop ax 
        ret       
        
    PrintSTDOUT ENDP
 
; IRASYK I FAILA SU AH-40h   
    
    PROC WriteToFile
        push ax
        
        mov ah, 40h
        int 21h
        jc klaida 
        
        cmp cx, ax
        jne dalinisIrasymas
        
      endWriteProc:
        pop ax
        ret    
		WriteToFile ENDP   
      klaida:  
        mov dx, offset klaidaIrasantPranesimas   
        call PrintSTDOUT
        jmp endWriteProc
      dalinisIrasymas:
        mov dx, offset dalinis
        call PrintSTDOUT
        jmp endWriteProc
 
; Patikrina ar trecias parametras baigiasi .txt   

    PROC patikrinkTreciaParametra
        push ax
        push bx
        push di
        push bp
        push si
        push cx
        
        xor cx, cx
        
        mov cl, rezultatuParametroIlgis
        sub cl, 4
        mov di, cx
        mov cl, 4 		; 4, nes tikrinam .txt
            
        xor ax, ax
        xor si, si
        xor bx, bx
        
        mov bx, offset rezultatuFailas
        mov bp, offset fragmentas 
        
      iesko:
        mov al, [bx+di] 
        mov ah, ds:[bp+si]
        cmp al, ah
        je plus
        inc bx
        inc si
        loop iesko
        jmp arLygu
        
      plus:
        inc flag
        inc bx
        inc si
        
        cmp flag, 4
        je pabaigaProc
        loop iesko
      arLygu:
        cmp flag, 4
        jne netinkamas
        cmp flag, 4      
        je pabaigaProc
        
      pabaigaProc:
        pop cx    
        pop si
        pop bp
        pop di
        pop bx
        pop ax
        
        ret   
      netinkamas:
        mov dx, offset netinkamasParametras
        call PrintSTDOUT
		jmp pagalba
     patikrinkTreciaParametra ENDP           
        
end start